Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1684346 - Review Request: ocaml-dune - A composable build system for OCaml
Summary: Review Request: ocaml-dune - A composable build system for OCaml
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robin Lee
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1684401
TreeView+ depends on / blocked
 
Reported: 2019-03-01 03:06 UTC by Andy Li
Modified: 2019-03-06 07:56 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-03-06 07:56:32 UTC
robinlee.sysu: fedora-review+


Attachments (Terms of Use)

Description Andy Li 2019-03-01 03:06:15 UTC
Spec URL: https://gist.github.com/andyli/e8837f66df97f8c659f114c063549da5/raw/e226609b4a93254162cde0e5581814e50d2316bd/ocaml-dune.spec
SRPM URL: https://gist.github.com/andyli/e8837f66df97f8c659f114c063549da5/raw/e226609b4a93254162cde0e5581814e50d2316bd/ocaml-dune-1.7.3-1.fc30.src.rpm
Description: A composable build system for OCaml
Fedora Account System Username: andyli

This is a re-review request for a package rename from jbuilder to ocaml-dune, following the upstream rename and a "ocaml-" prefix.

I've added in the spec file
Provides:      jbuilder = %{version}-%{release}
Obsoletes:     jbuilder < 1.0.1-3

Comment 1 Robin Lee 2019-03-01 06:33:12 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     License should be "MIT and LGPLv2 with exceptions and ISC" with respect
     to bundled libraries.
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/doc/ocaml-dune
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/doc/ocaml-dune,
     /usr/lib64/ocaml
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ocaml:
[x]: This should never happen

===== SHOULD items =====

Generic:
[x]: Sources can be downloaded from URI in Source: tag
[x]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: ocaml-dune-1.7.3-1.fc30.x86_64.rpm
          ocaml-dune-doc-1.7.3-1.fc30.noarch.rpm
          ocaml-dune-debuginfo-1.7.3-1.fc30.x86_64.rpm
          ocaml-dune-1.7.3-1.fc30.src.rpm
ocaml-dune.x86_64: W: spelling-error Summary(en_US) composable -> compo sable, compo-sable, compos able
ocaml-dune.x86_64: E: missing-call-to-chdir-with-chroot /usr/bin/dune
ocaml-dune.x86_64: W: no-manual-page-for-binary jbuilder
ocaml-dune-doc.noarch: W: spelling-error %description -l en_US composable -> compo sable, compo-sable, compos able
ocaml-dune-doc.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/ocaml-dune/objects.inv
ocaml-dune-doc.noarch: W: file-not-utf8 /usr/share/doc/ocaml-dune/objects.inv
ocaml-dune.src: W: spelling-error Summary(en_US) composable -> compo sable, compo-sable, compos able
4 packages and 0 specfiles checked; 1 errors, 6 warnings.




Rpmlint (debuginfo)
-------------------
Checking: ocaml-dune-debuginfo-1.7.3-1.fc30.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
ocaml-dune-doc (rpmlib, GLIBC filtered):
    ocaml-dune

ocaml-dune (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)

ocaml-dune-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
ocaml-dune-doc:
    ocaml-dune-doc

ocaml-dune:
    bundled(ocaml-cmdliner)
    bundled(ocaml-opam-file-format)
    bundled(ocaml-re)
    jbuilder
    ocaml-dune
    ocaml-dune(x86-64)

ocaml-dune-debuginfo:
    debuginfo(build-id)
    ocaml-dune-debuginfo
    ocaml-dune-debuginfo(x86-64)



Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -r -n ocaml-dune-1.7.3-1.fc30.src.rpm -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Ocaml, C/C++
Disabled plugins: Java, Python, SugarActivity, fonts, Haskell, Perl, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 Andy Li 2019-03-01 08:54:12 UTC
Thanks for the review!

I've modified the spec accordingly:
 * Changed license to "MIT and LGPLv2 with exceptions and ISC"
 * Fixed direction ownership.
 * Added a %check that print dune's version.

Spec URL: https://gist.github.com/andyli/e8837f66df97f8c659f114c063549da5/raw/566433f7b36682edbb23c286e8efa6ee495ce06f/ocaml-dune.spec
SRPM URL: https://gist.github.com/andyli/e8837f66df97f8c659f114c063549da5/raw/566433f7b36682edbb23c286e8efa6ee495ce06f/ocaml-dune-1.7.3-1.fc30.src.rpm

Comment 3 Robin Lee 2019-03-01 09:20:07 UTC
At last, the _boot/default/doc/dune-config.5 is not installed.
You should fix it before importing.

Though that's not a blocker, this package is approved by cheeselee.

Comment 4 Robin Lee 2019-03-01 09:24:02 UTC
And you may consider adding rpm macros like %dune_build, %dune_install, %dune_runtest to facilitate building of dune-based packages.

Comment 5 Andy Li 2019-03-01 09:36:10 UTC
Good catch. I've just fixed the missing manpage.

Spec URL: https://gist.github.com/andyli/e8837f66df97f8c659f114c063549da5/raw/566433f7b36682edbb23c286e8efa6ee495ce06f/ocaml-dune.spec
SRPM URL: https://gist.github.com/andyli/e8837f66df97f8c659f114c063549da5/raw/566433f7b36682edbb23c286e8efa6ee495ce06f/ocaml-dune-1.7.3-1.fc30.src.rpm

For adding rpm macros, I will think about it. There were some changes after the 1.0 release that affect how libraries should be built. e.g. OCaml warnings became build errors when `-p` and `--profile=release` is not used. I guess having rpm macros would indeed help maintain the dune-built packages.

Comment 7 Ben Rosser 2019-03-01 15:54:36 UTC
Hey, thanks for taking care of this! It was on my list of things to do but I kept putting it off. :(

I would suggest adding a Provides on "dune"; I named the package "jbuilder" originally because it's an application, not a library.

I also agree it makes sense to provide RPM macros for dune-based packages (and indeed, ocaml packages generally).

Comment 8 Andy Li 2019-03-01 16:48:21 UTC
Hi Ben,

I added the prefix to be consistent with openSUSE's ocaml-dune package.
I've no objection against adding a provides on "dune", or even just name it as "dune" instead of "ocaml-dune".
For the record, Debian currently package it without any prefix, but also considered adding one as discussed in https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=919953:

> ---DRAFT---DRAFT---DRAFT---DRAFT---DRAFT---DRAFT---DRAFT---DRAFT---
> 
> 1. Dune (numerics) does not see a good enough reason to stop dune (ocaml)
>    taking the /usr/bin/dune filename.
> 
> 2. Dune (numerics) does not see a problem in dune (ocaml) using "dune" or
>    "libdune" in package names, as long as "ocaml" also appears in the package
>    name.
> 
> ---DRAFT---DRAFT---DRAFT---DRAFT---DRAFT---DRAFT---DRAFT---DRAFT---

Best,
Andy

Comment 9 Andy Li 2019-03-01 16:50:32 UTC
Assigning to Robin as required by https://pagure.io/releng/fedora-scm-requests/issue/10074

Comment 10 Robin Lee 2019-03-02 02:11:32 UTC
(In reply to Andy Li from comment #9)
> Assigning to Robin as required by
> https://pagure.io/releng/fedora-scm-requests/issue/10074

I am sorry. You may have to open a new issue.

Comment 12 Gwyn Ciesla 2019-03-04 14:52:51 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/ocaml-dune


Note You need to log in before you can comment on or make changes to this bug.